﻿/**
 @Name：WeChatShare 初版的微信分享模板
 @Author：zj - 2016-08-28
 */

//微信头
var WECHAT_HEARDER = "http://m.somfor.cn/api/getwxsignature.asp?url=";
//微信标题
var title="连贯APP";
//图片Url
var img_Url = '';
//分享Url
var matchmakerUrl = "";
//分享描述
var discription = '';

/**
 * @param var pictureUrl 分享图片的地址
 * @param var content  分享描述
 * @param var shareUrl 分享链接
 * @author zj
 * */
var WeChatShareInit = function(pictureUrl,content,shareUrl){
		//分享图片Url
		img_Url = pictureUrl||"../../images/app/login_register.jpg";
		//描述
		discription = content||"";
		//分享Url
		matchmakerUrl = shareUrl||"";
		//调用分享方法
		shareToWeChat(function(WeChatData){
			//对返回值进行判定
			if(!WeChatData.data){
			//提示信息
			showErrorMsg("无法链接到网络");
			}else{
			//配置微信
			configWeChat(WeChatData.data);
			}
		});	
}

//获取签名对象
var shareToWeChat = function(fnSuc) {
	//获取签名地址
	var Share_URL = (WECHAT_HEARDER + window.location.href) || "";
	//AJAX操作，获取微信签名
	$.ajax({
		url: Share_URL,
		data: {},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 100000, //超时时间设置为10秒；
		success: function(data) {
			//关闭加载框
			closeWaiting();
			//服务器返回响应，根据响应结果，分析是否登录成功；
			if (data.status == 0) {
				//回调信息
				fnSuc && fnSuc(data);
			} else {
				showErrorMsg(data.msg);
			}
		},
		error: function(xhr, type, errorThrown) {
			closeWaiting();
			//异常处理
			showErrorMsg("网络错误，请稍后重试");
		},
		beforeSend:function(){
		//显示等待框
			showWaiting();
		}
	});
}

//配置微信
var configWeChat = function(WeChatData) {
	wx.config({
		debug: false, 
		appId: WeChatData.appId,
		timestamp: WeChatData.timestamp, 
		nonceStr: WeChatData.nonceStr, 
		signature: WeChatData.signature,
		jsApiList: [
			// 所有要调用的 API 都要加到这个列表中
			'onMenuShareTimeline',
			'onMenuShareAppMessage',
			'onMenuShareQQ',
			'onMenuShareWeibo'
		]
	});
}

//加载调用的微信方法
wx.ready(function () {
    	wx.onMenuShareTimeline({
        title: title, // 分享标题
        link: matchmakerUrl, // 分享链接
        imgUrl: img_Url, // 分享图标
        success: function () { 
        	// 用户确认分享后执行的回调函数
        	showSuccMsg("分享成功！");
        },
        cancel: function () { 
            // 用户取消分享后执行的回调函数
        showSuccMsg("已取消分享!");
        }
    });
    
    wx.onMenuShareAppMessage({
        title: title, // 分享标题
        desc: discription, // 分享描述
        link: matchmakerUrl, // 分享链接
        imgUrl: img_Url, // 分享图标
        type: 'link', // 分享类型,music、video或link，不填默认为link
        dataUrl: '', // 如果type是music或video，则要提供数据链接，默认为空
        success: function () { 
            // 用户确认分享后执行的回调函数
               showSuccMsg("分享成功！");
        },
        cancel: function () { 
            // 用户取消分享后执行的回调函数
              showSuccMsg("已取消分享!");
        }
    });
    
    wx.onMenuShareQQ({
        title: title, // 分享标题
        desc: discription, // 分享描述
        link: matchmakerUrl, // 分享链接
        imgUrl: img_Url, // 分享图标
        success: function () { 
           // 用户确认分享后执行的回调函数
          showSuccMsg("分享成功!");
        },
        cancel: function () { 
           // 用户取消分享后执行的回调函数
             showSuccMsg("已取消分享!");
        }
    });
    wx.onMenuShareWeibo({
        title: title, // 分享标题
        desc: "", // 分享描述
        link: matchmakerUrl, // 分享链接
        imgUrl: img_Url, // 分享图标
        success: function () { 
           // 用户确认分享后执行的回调函数
           showSuccMsg("分享成功！");
        },
        cancel: function () { 
            // 用户取消分享后执行的回调函数
             showSuccMsg("已取消分享!");
        }
    });
});