/**
 * 程序当前的 “注册/登录” 等操作， “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.userName = loginInfo.userName || '';
		loginInfo.passWord = loginInfo.passWord || '';
		if (loginInfo.userName.length < 10) {
			return callback('手机号最短为 10个字符');
		}
		if (loginInfo.passWord.length < 3) {
			return callback('密码最短为 3 个字符');
		}
		
		loginInfo.passWord = MD5(loginInfo.passWord);
		loginInfo.deviceType = "5";
		loginInfo.deviceId = plus.device.uuid;
		var url = apiurl+'/IlgSuppUser/login.do';
		//服务器通讯
		makeUrl(url,loginInfo,"用户登录");
		mui.ajax(timestamp(url),{
			data:loginInfo,
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				//关闭加载框
				closeWaiting();
				//服务器返回响应，根据响应结果，分析是否登录成功；
				if(data.returncode == 00){
					sts_login();
					//登录账号保存到本地
					setStorage("$Member_User_S",loginInfo.userName);
					//用户信息保存到本地
					setStorage("$Member_Info_S",data.data);
					owner.saveclientid(data.data);
					return owner.createState(data.data.USERUUID,data.data.TOKEN, callback);
				}else{
					return callback(data.message);
				}
			},
			error:ajaxErrorCommon,
			beforeSend : beforeSendCommon
		});
	};

	/**
	 * 保存clientid
	 * @param data
	 */
	owner.saveclientid = function(data){
		var info = plus.push.getClientInfo();
		//配置参数
		var param = {
			clientid: info.clientid
		};
		var userid = data.USERUUID || 0;
		var token = data.TOKEN;
	};
	//创建登录状态
	owner.createState = function(useruuid,token, callback) {
		var state = owner.getState();
		state.useruuid = useruuid;
		state.token = token;
		owner.setState(state);
		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
}(mui, window.app = {}));