/**
 * app应用内更新
 * 比较应用版本号，来检测更新
 * 接口1：获取最新版本号与此版本号对应的更新文件网络地址，与本机版本号比对，检测是否需要升级
 * 接口2：如果需要升级，下载文件，提示用户更新，确认后进行更新升级
 * 接口3:更新应用资源
 */
//当前版本号
var wgtVer = null;
//检测更新
function checkUpdate() {
	var param = new Object();
	param.action = '/IlgCheckupate/appUpdateResult/2.do';
	// 获取本地应用资源版本号
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version;
		console.log("当前应用版本：" + wgtVer);
		//获取服务器上的版本号
		getServerVersion(param, function(ret) {
			var data = ret.data;
			if(data != null && data != "") {
				if(wgtVer && data.VERSION && (wgtVer != data.VERSION)) {
					plus.nativeUI.confirm("检测到新版本，是否升级?", function(e) {
						if(e.index == 0) {
							downWgt(data.EDITIONHTTP); // 下载升级包
						}
					}, "", ["升级", "暂不升级"]);
				}
			}
		});
	});

}

//下载升级文件
function downWgt(wgtUrl) {
	if(wgtUrl) {
		plus.nativeUI.showWaiting("下载升级文件...");
		plus.downloader.createDownload(wgtUrl, {
			filename: "_doc/update/"
		}, function(d, status) {
			if(status == 200) {
				console.log("下载wgt成功：" + d.filename);
				installWgt(d.filename); // 安装wgt包
			} else {
				console.log("下载wgt失败！");
				plus.nativeUI.alert("下载升级文件失败！");
			}
			plus.nativeUI.closeWaiting();
		}).start();
	} else {
		plus.nativeUI.alert("未获取到升级地址！");
	}
}

// 更新应用资源
function installWgt(path) {
	plus.nativeUI.showWaiting("安装升级文件...");
	plus.runtime.install(path, {}, function() {
		plus.nativeUI.closeWaiting();
		console.log("安装wgt文件成功！");
		plus.nativeUI.alert("应用资源更新完成！", function() {
			plus.runtime.restart();
		});
	}, function(e) {
		plus.nativeUI.closeWaiting();
		console.log("安装wgt文件失败[" + e.code + "]：" + e.message);
		plus.nativeUI.alert("安装升级文件失败[" + e.code + "]：" + e.message);
	});
}