/* 系统配置 */
var debug = false;

//api基础设置
var apiurl = 'http://192.168.0.202:8080/LgApiInterface'; //测试环境
var apiimgurl = 'http://lgapp.oss-cn-shanghai.aliyuncs.com/';
if(!debug) {
	apiurl = "http://139.224.41.163/LgApiInterface"; //预生产环境
}
//通用提示消息
var messageshowval="服务器开小差？网络不给力？重新试试呗！！";
/*
 *---------------------------------------------------------------------------------
 * 数据API封装
 * --------------------------------------------------------------------------------
 * */
//获取单条数据
var getdetial = function(action, data, fnSuc) {
		var url = apiurl + action;
		var args = data;
		//获取基本参数
		var userInfoStr = getUserInfo(true);
		if(userInfoStr) {
			args.userUuid = userInfoStr.USERUUID;
			args.token = userInfoStr.TOKEN;
		} else {
			return;
		}
		//debug
		if(debug) {
			makeUrl(url, args, "[getdetial]");
		}
		//处理参数
		args = parameterHandle(args);
		//AJAX操作，获取数据
		$.ajax(timestamp201696(url, args.timestamp), {
			data: args,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				//关闭加载框
				closeWaiting();
				//服务器返回响应，根据响应结果，分析是否登录成功；
				if(data.returncode == 00) {
					if(data.data == "{}") {
						fnSuc && fnSuc(null);
					} else {
						fnSuc && fnSuc(data.data);
					}
				}else {
					toastShow(messageshowval);
					fnSuc && fnSuc(null);
				}
			},
			error: ajaxErrorCommon,
			beforeSend: beforeSendCommon
		});
	}
	//获取服务器上版本号
var getServerVersion = function(param, fnSuc) {
	//弹出加载框
	var url = apiurl + param.action;
	var args = new Object();
	//AJAX操作，获取数据
	if(debug) {
		makeUrl(url, args, "【getServerVersion】");
	}
	//AJAX操作，获取数据
	mui.ajax(timestamp(url), {
		data: args,
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			//关闭加载框
			plus.nativeUI.closeWaiting();
			//服务器返回响应，根据响应结果，分析是否登录成功；
			if(data.returncode == 00) {
				fnSuc && fnSuc(data);
			}else {
				toastShow(messageshowval);
			}
		},
		error: ajaxErrorCommon
	});
}

/*  获取列表数据
 *	返回data
 *
 * */
var getdatalist = function(param, fnSuc) {
	var url = apiurl + param.action;
	var args = new Object();
	args = param;
	//获取基本参数
	var userInfoStr = getUserInfo(false);
	if(userInfoStr) {
		args.userUuid = userInfoStr.USERUUID;
		args.token = userInfoStr.TOKEN;
	} else {
		mui.toast("没有登录，请先登录");
		return;
	}
	//AJAX操作，获取数据
	if(debug) {
		makeUrl(url, args, "【getdatalist】");
	}
	//处理参数
	args = parameterHandle(args);
	//AJAX操作，获取数据
	$.ajax(timestamp201696(url, args.timestamp), {
		data: args,
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			//关闭加载框
			closeWaiting();
			//服务器返回响应，根据响应结果，分析是否登录成功；
			if(data.returncode == 00) {
				fnSuc && fnSuc(data);
			} else {
				toastShow(messageshowval);
				fnSuc && fnSuc(null);
			}
		},
		error: ajaxErrorCommon,
		beforeSend: beforeSendCommon
	});
}

//单条数据删除
var deldata = function(param, fnSuc) {
	var url = apiurl + param.action;
	//获取基本参数
	var userInfoStr = getUserInfo(false);
	if(userInfoStr) {
		param.userUuid = userInfoStr.USERUUID;
		param.token = userInfoStr.TOKEN;
	} else {
		mui.toast("没有登录，请先登录");
		return;
	}
	plus.nativeUI.confirm("您确定要删除本条数据吗？", function(e) {
		if(e.index == 0) {
			//处理参数
			param = parameterHandle(param);
			$.ajax(timestamp201696(url, param.timestamp), {
				data: param,
				dataType: 'json', //服务器返回json格式数据
				type: 'post', //HTTP请求类型
				timeout: 10000, //超时时间设置为10秒；
				success: function(data) {
					//关闭加载框
					closeWaiting();
					//服务器返回响应，根据响应结果，分析是否登录成功；
					if(data.returncode == 00) {
						window.location.href = window.location.href;
					}else{
						toastShow(messageshowval);
					}
				},
				error: ajaxErrorCommon,
				beforeSend: beforeSendCommon
			});
		}
	}, "", ["确定", "取消"]);
}

/*
 *---------------------------------------------------------------------------------
 * 自定义函数
 * --------------------------------------------------------------------------------
 * */

//给参数签名
function parameterHandle(param) {
	var getTimestamp = new Date().getTime();
	param.timestamp = getTimestamp; //时间戳
	//设备相关信息
	param.deviceType = mui.os.android ? 'a' : 'i'; //平台类型，i表示iOS平台，a表示Android平台。
	param.deviceId = plus.device.imei; //设备标识
	param.appId = plus.runtime.appid; //当前应用程序ID
	param.deviceModel = plus.device.model; //设备型号
	param.appVersion = plus.runtime.version; //当前应用程序版本号
	param.plusVersion = plus.runtime.innerVersion; //基座版本号
	param.net = '' + plus.networkinfo.getCurrentType(); //网络环境
	//去掉空参数并从小到大排序
	var keys = getObjectKeys(param);
	var prastr = "";
	//排序过后并以key=value+"&"的方式返回
	for(var i = 0; i < keys.length; i++) {
		var key = keys[i];
		var value = param[key];
		if(isChinese(value)) {
			value = encodeURI(value);
			value = value.replace("+", "%20");
		}
		if(i == keys.length - 1) { //拼接时，不包括最后一个&字符
			prastr = prastr + key + "=" + value;
		} else {
			prastr = prastr + key + "=" + value + "&";
		}
	}
	prastr = prastr + "&38LTW7Cb2P&VjwDESA@4yN5q3gOQu!"
	var sign = COMMD5(prastr);
	param.sign = sign;
	return param;
}

//获取所有数组keys
function getObjectKeys(object) {
	var keys = [];
	for(var property in object) {
		var tempval = object[property];
		if(tempval == null || tempval == '' || property == 'action') {
			continue;
		}
		keys.push(property);
	}
	keys = keys.sort();
	return keys;
}

//获取所有值
function getObjectValues(object) {
	var values = [];
	for(var property in object) {
		values.push(object[property]);
	}
	return values;
}
//给URL加上时间戳(新版2016/9/6)
function timestamp201696(url, getTimestamp) {
	if(url.indexOf("?") > -1) {
		url = url + "&timestamp=" + getTimestamp
	} else {
		url = url + "?timestamp=" + getTimestamp
	}
	return url;
}
//给URL加上时间戳
function timestamp(url) {
	var getTimestamp = new Date().getTime();
	if(url.indexOf("?") > -1) {
		url = url + "&timestamp=" + getTimestamp
	} else {
		url = url + "?timestamp=" + getTimestamp
	}
	return url;
}

//判断是否包含中文
function isChinese(str) {
	var res = false;
	if(escape(str).indexOf("%u") < 0) {
		res = false;
	} else {
		res = true;
	}
	return res;
}

//换算成年-月-日
function formatDate(date) {
	var y = date.getFullYear();
	var m = date.getMonth() + 1;
	m = m < 10 ? '0' + m : m;
	var d = date.getDate();
	d = d < 10 ? ('0' + d) : d;
	return y + '-' + m + '-' + d;
}

//换算成年-月-日-时-分-秒
function formatDateTime(date) {
	var y = date.getFullYear();
	var m = date.getMonth() + 1;
	m = m < 10 ? ('0' + m) : m;
	var d = date.getDate();
	d = d < 10 ? ('0' + d) : d;
	var h = date.getHours();
	var minute = date.getMinutes();
	minute = minute < 10 ? ('0' + minute) : minute;
	return y + '-' + m + '-' + d + ' ' + h + ':' + minute;
}

/*
 * 两数相除向下取整，如Math.floor(0.60)与Math.floor(0.49)，结果均为0；
 * a为除数，b为被除数
 * */
function dividedby(divisor, dividend) {
	var result = Math.floor(divisor / dividend);
	return result;
}
//弹出提示
function toastShow(msg){
	mui.toast(msg);
}
/*
 *-------------------------------------
 *系统应用工具
 *-------------------------------------
 *
 **/
/**
 *
 * @param xhr xhr实例对象
 * @param type 错误描述，可取值："timeout", "error", "abort", "parsererror"、"null"
 * @param errorThrown 可捕获的异常对象
 */
function ajaxErrorCommon(xhr, type, errorThrown) {
	//关闭加载框
	plus.nativeUI.closeWaiting();
	if(type === "abort") {
		//异常处理；
		mui.toast("网络断开，请检查是否已经连上网络");
	}
	if(type === "timeout") {
		//异常处理；
		mui.toast("请求超时,请重试");
	}
	if(type === "error") {
		//异常处理；
		if(xhr.status == 500) {
			mui.toast("服务器异常!");
		}
		//访问无效
		if(xhr.status == 404) {
			mui.toast("请求的页面不存在!");
		}
		//非法访问
		if(xhr.status == 401) {
			mui.toast("登录已失效，请重新登录!");
		}
		//请求失效
		if(xhr.status == 408) {
			mui.toast("请求失效,请刷新!");
		}
	}
	if(type === "parsererror") {
		//异常处理；
		mui.toast("解析错误");
	}
	if(type === "null") {
		//异常处理；
		mui.toast("服务器错误");
	}
}
/**
 * 发送前处理
 */

function beforeSendCommon() {
	//显示等待框
	showWaiting();
}

/**
 * 闭加载框
 * *
 */
function closeWaiting() {
	plus.nativeUI.closeWaiting();
}
/*
 *---------------------------------------------------------------------------------
 * 封装local Storage
 * --------------------------------------------------------------------------------
 * */

//根据key获取local Storage
function getStorage(key) {
	return localStorage.getItem(key);
}

//存储local Storage(本地只能存储string类型，如需要存储对象，使用JSON转换)
function setStorage(key, val) {
	if(typeof val != 'string') {
		val = JSON.stringify(val);
	}
	try {
		localStorage.setItem(key, val);
	} catch(e) {
		alert("请关闭无痕模式，否则系统无法登陆")
	}

}

//根据key删除local Storage
function removeStorage(key) {
	localStorage.removeItem(key);
}
//清除应用所有的键值对存储数据(慎用)

function clearStorage() {
	localStorage.clear();
}

//获取默认定位的城市
function getDefaultCity() {
	var ltion;
	var cityStr = getStorage("$citycode");
	var distStr = getStorage("$distcode");
	if(cityStr && distStr) {
		ltion = JSON.parse(distStr);
		ltion.parent = JSON.parse(cityStr);
	}
	return ltion;
}
/**
 *获取登录账号 
 *
 * *
 */
function getUserAccount() {
	var userAcc = null;
	var userAcc = getStorage("$Member_User_S");
	return userAcc;
}

/**
 * 获取用户登陆信息
 * @param flag 是否处理
 * @param callback 自己处理
 * @returns {*}
 */
function getUserInfo(flag, callback) {
	var userInfo = null;
	var userStr = getStorage("$Member_Info_S");
	if(userStr) {
		userInfo = JSON.parse(userStr);
		sp("获取用户本地储存", userInfo)
		return userInfo;
	} else {
		console.log("用户还没有登录");
		if(flag) {
			console.log("自行处理");
			if(typeof callback == "function") {
				callback();
			} else {
				console.log("跳转登陆页面");
				mui.toast("登录已失效,请重新登录");
				setTimeout(function() {
					//打开登录页面
					plus.webview.show("login.html");
				}, 1000);
			}
		} else {
			console.log("不处理");
			return;
		}
	}
}

/**
 * 从服务器获取用户登陆信息
 * @param callback
 */
function getUserInfoRemote(callback) {
	var url = apiurl + "/api/login.asp?action=getuserinfo";
	if(debug) {
		makeUrl(url, {});
	} //debug
	//AJAX操作，提交数据
	mui.ajax(timestamp(url), {
		data: {},
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			//服务器返回响应，根据响应结果，分析是否登录成功；
			if(data.status == 00) {
				callback && callback(data);
			} else {
				mui.toast(data.msg);
			}
		},
		error: ajaxErrorCommon
	});
}

//用户退出
function userLoginOut() {
	loginOut();
	removeStorage("$Member_Info_S");
}
/**
 * 跳转到全局搜索页面
 * searchKey为输入框的搜索条件
 */
var turnToSearchPage = function(searchKey) {
	$.openWindow({
		id: 'searchPage',
		url: '../searchpage/searchPage.html',
		waiting: {
			autoShow: true, //自动显示等待框，默认为true
			title: '正在加载...' //等待对话框上显示的提示内容
		},
		extras: {
			searchKey: searchKey
		},
		styles: {
			left: '0px'
		}
	});
}

/**
 * 判断对象不为空
 * @param obj
 * @returns {boolean}
 */
var isNotNull = function(obj) {
		if(typeof obj != "undefined" && obj != null && obj != '') {
			return true;
		} else {
			return false;
		}
	}
	/*
	 *---------------------------------------------------------------------------------
	 * 日志打印封装
	 * --------------------------------------------------------------------------------
	 * */
	/**
	 * 打印日志
	 * @param file 文件名
	 * @param msg  文字信息
	 * @param obj 对象
	 */
var print = function(file, msg, obj) {
		if(debug) {
			file = file || "";
			if(file.length > 0) {
				console.log(new Date() + "[" + file + "]--" + msg + JSON.stringify(obj));
			} else {
				console.log(new Date());
			}
		}
	}
	/**
	 * 简易打印日志
	 */
var sprint = function(obj) {
		if(debug) {
			obj = obj || "";
			if(obj) {
				console.log("*************start*****************");
				console.log(new Date() + "--" + JSON.stringify(obj));

			} else {
				console.log("*************start*****************");
				console.log(new Date())
			}
		}
	}
	//
var pprint = function(obj) {
		if(debug) {
			obj = obj || "";
			if(obj) {
				console.log(new Date() + "--" + JSON.stringify(obj));
			} else {
				console.log(new Date())
			}
		}
	}
	//
var eprint = function(obj) {
		if(debug) {
			obj = obj || "";
			if(obj) {
				console.log(new Date() + "--" + JSON.stringify(obj));
				console.log("----------------end------------------");
			} else {
				console.log(new Date());
				console.log("----------------end------------------");
			}
		}
	}
	//
var jp = function(obj) {
		obj = obj || {};
		return JSON.stringify(obj);
	}
	//
var sp = function(str, obj) {
		if(debug) {
			str = str || new Date();
			console.log(str, jp(obj));
		}
	}
	//
var cl = function(str, obj) {
	if(debug) {
		console.log(str, obj || jp({}));
	}
}

/**
 * 给同一个class绑定点击事件
 * @param className
 * @param callback
 */
var bindEventByClassName = function(className, callback) {
		mui.each(document.querySelectorAll(className), function(i, o) {
			o.addEventListener('tap', callback);
		})
	}
	/**
	 * 根据id绑定事件
	 * @param id
	 * @param callback
	 */
var bindEventById = function(id, callback) {
	document.getElementById(id).addEventListener('tap', callback);
}

/**
 * 页面返回事件
 */
var bindBackPageEventById = function(id) {
	document.getElementById(id).addEventListener("tap", function() {
		mui.back();
	});
}

/**
 * 下拉刷新方法
 * @pageParamTemp 查询条件
 * @RETDATA全局对象
 * @author 
 */
var downToFlush = function(pageParamTemp, RETDATA, flag, fnSuc) {
	if(flag == 1) {
		var DataTemp = new Array();
		pageParamTemp.iDisplayStart = 0;
		console.log("下拉刷新数据集" + JSON.stringify(RETDATA));
		getdatalist2(pageParamTemp, function(ret) {
			//非空判断
			if(ret.data.aaData.length == 0) {
				showWarnMsg("没有搜索到数据");
			} else {
				for(i = 0; i < ret.data.aaData.length; i++) {
					var temp = RETDATA.get(ret.data.aaData[i].id);
					console.log("下拉数据:" + JSON.stringify(ret));
					if(temp == null) {
						DataTemp.push(ret.data.aaData[i]);
					};
				}
				console.log("下拉:" + JSON.stringify(DataTemp));
				fnSuc && fnSuc(DataTemp);
			}
		});
	} else {
		var DataTemp = new Array();
		pageParamTemp.iDisplayStart = 0;
		console.log("下拉刷新数据集" + JSON.stringify(RETDATA));
		getdatalist(pageParamTemp, function(ret) {
			//非空判断
			if(ret.data.aaData.length == 0) {
				showWarnMsg("没有搜索到数据");
			} else {
				for(i = 0; i < ret.data.aaData.length; i++) {
					var temp = RETDATA.get(ret.data.aaData[i].id);
					console.log("下拉数据:" + JSON.stringify(ret));
					if(temp == null) {
						DataTemp.push(ret.data.aaData[i]);
					};
				}
				console.log("下拉:" + JSON.stringify(DataTemp));
				fnSuc && fnSuc(DataTemp);
			}
		});
	}
}

/** 
 * 将数值四舍五入(保留2位小数)后格式化成金额形式
 * @param num 数值(Number或者String)
 * @return 金额格式的字符串,如'1,234,567.45'
 * @type String
 * @
 */

var formatCurrency = function(num) {
	num = num || 0;
	num = num.toString().replace(/\$|\,/g, '');
	if(isNaN(num))
		num = "0";
	sign = (num == (num = Math.abs(num)));
	num = Math.floor(num * 100 + 0.50000000001);
	cents = num % 100;
	num = Math.floor(num / 100).toString();
	if(cents < 10)
		cents = "0" + cents;
	for(var i = 0; i < Math.floor((num.length - (1 + i)) / 3); i++)
		num = num.substring(0, num.length - (4 * i + 3)) + '' +
		num.substring(num.length - (4 * i + 3));
	return(((sign) ? '' : '-') + num + '.' + cents);
}

// 页面传值
function GetQueryString(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
	var r = window.location.search.substr(1).match(reg);
	if(r != null) {
		return(r[2]);
	}
	return null;
}

/** 
 * 获取url，？之后的参数，并以key，value形式返回
 * @ 作者 zj
 */
var GetRequest = function() {
	var url = location.search; //获取url中"?"符后的字串   
	var theRequest = new Object();
	if(url.indexOf("?") != -1) {
		var str = url.substr(1);
		strs = str.split("&");
		for(var i = 0; i < strs.length; i++) {
			theRequest[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
		}
	}
	return theRequest;
}

/**
 * 页面窗口跳转
 */
//
var openToRegister = function(url) {
	window.location.href = url;
}

/**
 * 判断是否是微信浏览器
 * @returns {boolean}
 */
var is_weixin = function() {
	var ua = navigator.userAgent.toLowerCase();
	if(ua.match(/MicroMessenger/i) == "micromessenger") {
		return true;
	} else {
		return false;
	}
}

/**
 * 头部模板
 * @type {string}
 */
var headerTplHtml =
	'<header class="header  mui-bar mui-bar-nav">' +
	'<div class="row">' +
	'<div class="col-lg-2 col-md-2 col-sm-2 col-xs-2">' +
	'<span class="back">' +
	'<img src="../../images/app/back.png"/></span>' +
	'</div>' +
	'<div class="col-lg-7 col-md-7 col-sm-7 col-xs-7"><span class="kehu">{{d.pagename}}</span></div>' +
	'<div class="col-lg-3 col-md-3 col-sm-3 col-xs-3"><span class="add">' +
	'{{# if(d.actionimg != ""){ }}' +
	'<img class="headeraction" src="{{d.actionimg}}"/>' +
	'{{# } }}' +
	'</span></div>' +
	'</div>' +
	'</header>';

/**
 * 给页面添加头部
 * @param container 容器id
 * @param pageName 页面名称
 * @param backPage
 *
 * var action = {
 *		img:"../../images/app/add.png",
 *		backpage:"/hongniang/pages/app/index.html",
 *		do:"/hongniang/pages/app/addxiashu.html"
 *	}
 *addHeader("#headerDiv","我的下属",action);
 *
 */
var addHeader = function(container, pageName, action) {
	var defaultV = {
		img: null,
		backpage: null,
		do: null
	}
	action = action || defaultV;
	if(!is_weixin()) {
		var renderObj = {
			pagename: pageName,
			actionimg: action.img || ''
		};
		var tplObj = laytpl(headerTplHtml);
		tplObj.render(renderObj, function(html) {
			$(container).append(html);
		});

		$(".back").on("click", function() {
			if(action.backpage) {
				openToRegister(action.backpage);
			} else {
				window.history.back()
			}
		});

		$(".headeraction").on("click", function() {
			openToRegister(action.do);
		});

		$(container).css("padding-top", "60px");

	}
}

/**
 * 公共尾部
 * @type {string}
 */
var footerTplHtml =
	'<footer class="footerBg">' +
	'<ul>' +
	'</ul>' +
	'</footer>';

var liTplHtml =
	'<a href="{{d.actionUrl}}">' +
	'<li>' +
	'<span style="width: 80px"><img class="footeraction" style="width: 25px;height: 25px;" src="{{d.actionimg}}"/>{{d.actionName}}</span>' +
	'</li>' +
	'</a>';

/**
 *
 * @param container 容器
 * @param buttoms 按钮数组对象
 *
 * 添加额外的按钮
 * var footeraction = [
 *{actionName:"首页",actionUrl:"/hongniang/pages/app",actionimg:"../../images/app/toumingwawa.png"},
 *{actionName:"添加下属",actionUrl:"/hongniang/pages/app/addxiashu.html",actionimg:"../../images/app/jiahao.png"},
 *];
 *addFooter("#footerDiv",footeraction);

 *默认为首页按钮
 *  addFooter("#footerDiv",null);

 */
var addFooter = function(container, buttoms) {
	var defaultV = [{
		actionName: "首页",
		actionUrl: "index.html",
		actionimg: "../../images/shouye.png"
	}];
	buttoms = buttoms || defaultV;

	$(container).append(footerTplHtml);

	var ulObj = $(container).find("ul");
	var tplobj = laytpl(liTplHtml);
	$.each(buttoms, function(i, o) {
		tplobj.render(o, function(html) {
			ulObj.append(html);
		});
	})
}

var menuHtmlTpl =
	'<div class="info-nr">' +
	'<div id="info-nr-phone" class="info-nr-phone info-nr-phone2">' +
	'<section id="toMenu"></section>' +
	'<div id="menuList"></div>' +
	'</div>' +
	'</div>';
var menuItemHtmlTpl =
	'<div class="menu_0{{d.index}} to_2_0{{d.index}}"> <a href="{{d.url}}"></a></div>';

var addMenu = function(container, buttoms) {
	var defaultV = [{
		url: "index.html",
		img: "../../images/shouye.png"
	}];
	buttoms = buttoms || defaultV;

	$(container).append(menuHtmlTpl);

	var divObj = $("#menuList");
	var tplobj = laytpl(menuItemHtmlTpl);
	$.each(buttoms, function(i, o) {
		o.index = i + 1;
		tplobj.render(o, function(html) {
			divObj.append(html);
		});
	});

	$("#toMenu").on('click', function() {
		$(".info-nr-phone").toggleClass("info-nr-phone2");
		$.each(buttoms, function(i, o) {
			var index = i + 1;
			$(".menu_0" + index).toggleClass("to_2_0" + index);
			$(".to_2_0" + index).css("background", "url(" + o.img + ") 50% 50% no-repeat rgba(0, 0, 0, 0.7)");
			$(".to_2_0" + index).css("background-size", "auto 85%");
		});
	});

	//加载微信分享
	//加载js脚本
	/*document.write("<script type='text/javascript' src='http://res.wx.qq.com/open/js/jweixin-1.0.0.js'></script>");
	if(typeof WeChatShareInit != "undefined" && !WeChatShareInit){
		document.write("<script src='../../js/WeChatShare.js'></script>");
	}
	setTimeout(function(){
		var user = getUserInfo();
		var shareurl = apiurl + "/app/?creator=" + user.userdata.creator2 + "&token=" + user.department.token + "&recommender=" + user.id + "&relationid=" + user.department.id;
		WeChatShareInit(user.department.cpicture,
			user.department.content,
			shareurl);
	},2000)*/

}

//注销接口
var loginOut = function(fnSuc) {
	var url = apiurl + "/IlgSuppUser/logout.do";
	var args = new Object();
	args.deviceType = '5';
	args.deviceId = plus.device.uuid;
	//获取基本参数
	var userInfoStr = getUserInfo();
	if(userInfoStr) {
		args.userUuid = userInfoStr.USERUUID;
		args.token = userInfoStr.TOKEN;
	} else {
		return;
	}
	if(debug) {
		makeUrl(url, args, 'loginOut');
	}
	args = parameterHandle(args);
	//AJAX操作，获取数据
	$.ajax(timestamp201696(url, args.timestamp), {
		data: args,
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 3000, //超时时间设置为3秒；
		success: function(data) {
			//关闭加载框
			closeWaiting();
			//服务器返回响应，根据响应结果，分析是否登录成功；
			if(data.returncode == 00) {
				//注销成功
			}
		},
		error: function(xhr, type, errorThrown) {
			closeWaiting();
			//异常处理
//			showErrorMsg("网络错误，请稍后重试");
		}
	});
}

/**
 * 获取浏览器类型和版本，依赖jquery
 */
function getOs() {
	var Sys = {};
	var ua = navigator.userAgent.toLowerCase();
	var s;
	(s = ua.match(/rv:([\d.]+)\) like gecko/)) ? Sys.ie = s[1]:
		(s = ua.match(/msie ([\d.]+)/)) ? Sys.ie = s[1] :
		(s = ua.match(/firefox\/([\d.]+)/)) ? Sys.firefox = s[1] :
		(s = ua.match(/chrome\/([\d.]+)/)) ? Sys.chrome = s[1] :
		(s = ua.match(/opera.([\d.]+)/)) ? Sys.opera = s[1] :
		(s = ua.match(/version\/([\d.]+).*safari/)) ? Sys.safari = s[1] : 0;

	var rt = {};
	if(Sys.ie) {
		rt.os = "ie";
		rt.version = Sys.ie;
	}
	if(Sys.firefox) {
		rt.os = "firefox";
		rt.version = Sys.firefox;
	}
	if(Sys.chrome) {
		rt.os = "chrome";
		rt.version = Sys.chrome;
	}
	if(Sys.opera) {
		rt.os = "opera";
		rt.version = Sys.opera;
	}
	if(Sys.safari) {
		rt.os = "safari";
		rt.version = Sys.safari;
	}
	return rt;
}

/*
 * @param className 设置背景的.class名
 */
var getRelationPic = function(className) {
	if(className) {
		var relation = getRelation()[0] || getUserInfo().department;
		var temp = $(className);
		if(temp && relation.mainpic) {
			temp.css("background-image", "url(" + apiurl + relation.mainpic + ")");
		} else {
			if(debug)
				showErrorMsg("没有获取到背景对象，请检查传入参数！");
		}
	};
}

/**
 * 跳转页面
 * @param url 页面url
 * @param data 附加数据
 */
function openHtml(url, data) {
	sts_visit();
	data = data || {};
	mui.openWindow({
		id: url,
		url: url,
		show: {
			aniShow: 'pop-in'
		},
		extras: {
			data: data
		},
		waiting: {
			autoShow: false
		}
	});
}

//参数为true代表没有更多数据了。
var nomore = function() {
	mui('#pullrefresh').pullRefresh().endPulldownToRefresh(true);
	mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
}

/**
 * 上拉下拉后必须执行的操作
 * @param flag true 上拉刷新操作  false 下拉刷新操作
 */
var flush = function(flag) {
		flag = flag || false;
		if(flag) {
			mui('#pullrefresh').pullRefresh().endPullupToRefresh();
		} else {
			mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
		}
	}
	/*
	 * 没有登录就提醒
	 * 
	 * **/
var noLogin = function(view) {
	var HTML = "";
	view.append("<div id='noLoginDiv' class='item-logo'><a href='#'>请先登录</a>" + HTML + "</div>");
}

/**
 * 移除没有登录的div提示
 */
var removeNoLogin = function() {
	$("#noLoginDiv").remove();
}

/**
 * 如果页面上没有显示数据则加上相应的提示
 */
var noData = function(view, findelm) {
		var divSize = view.find(findelm);
		if(divSize.length > 0) {
			mui.toast("没有更多数据");
		} else {
			var HTML = "";
			view.append("<div id='noDataDiv' class='item-logo'><img src='../../images/car.png'/><div>你还没有相关运单</div>" + HTML + "</div>");
//			view.append("<div id='noDataDiv' class='item-logo'><a href='#'>暂无相关数据</a>" + HTML + "</div>");
		}
	}
	/**
	 * 移除没有数据的div提示
	 */
var removeNoData = function() {
	$("#noDataDiv").remove();
}

//上拉下拉刷新功能重置
var reopenfresh = function() {
	mui('#pullrefresh').pullRefresh().refresh(true);
	mui('#pullrefresh').pullRefresh().endPullupToRefresh((false));
}

/**
 * 下拉、上拉分页加载
 * @param flag true 分页  false 刷新
 * @param data 数据集
 * @param renderFun 渲染方法
 * @param map 数据map
 * @param view 容器
 * @param pageSum 数据总数
 */
var pagePullData = function(flag, data, renderFun, map, view, pageSum) {
	mui.each(data, function(index, object) {
		var resultStr = renderFun(object);
		if(!map.isExist(object.id)) {
			map.put(object.id, object.uid);
			if(flag) {
				//加载更多往后追加
				view.append(resultStr);
			} else {
				//下拉刷新往前追加
				view.prepend(resultStr);
			}
		}
	});
	if(flag) {
		if(map.size() == pageSum) {
			//页面集合数等于数据库总记录数代表没有更多数据
			nomore();
		} else {
			flush(true);
		}
	} else {
		flush();
	}
}

/**
 *修改状态栏颜色
 */
function setStatusbarRed() {
	// 设置系统状态栏背景色为红色
	mui.plusReady(function() {
		cl("设置状态栏颜色");
		plus.navigator.setStatusBarBackground("#fb4748");
		
	});
}

/**
 * 组装url
 * @param furl
 * @param param
 * @returns {string|*}
 */
function makeUrl(furl, param, str) {
	if(furl.indexOf("?") > -1) {
		furl = furl + "&";
	} else {
		furl = furl + "?";
	}
	mui.each(param, function(key, val) {
		furl += (key + "=" + val + "&");
	});
	var getTimestamp = new Date().getTime();
	furl += ("timestamp=" + getTimestamp);
	cl(str || "组装好的url", furl);
}

/**
 * app统计
 */

//统计应用启动次数
function sts_start() {
	plus.statistic.eventTrig("start");
	plus.statistic.eventStart("use");
}

//登录次数
function sts_login() {
	mui.plusReady(function() {
		plus.statistic.eventTrig("login");
	});
}

//页面使用时长开始
function sts_pageuse() {
	mui.plusReady(function() {
		plus.statistic.eventStart("pageuse");
	});
}
window.addEventListener('load', function(event) {
	mui.plusReady(function() {
		plus.statistic.eventStart("pageuse");
	});
});

/*
 * 页面使用时长结束
 * **/
var old_back = mui.back;
mui.back = function() {
	plus.statistic.eventEnd("pageuse");
	old_back();
}

//使用总时长
function sts_use() {
	plus.statistic.eventEnd("use");
}

//访问次数
function sts_visit() {
	plus.statistic.eventTrig("visit");
}

//拨打电话
function toDial(mobile, cof) {
	if(mobile) {
		plus.device.dial(mobile, cof);
	} else {
		mui.toast("未获取到号码");
	}
}
//用户登录状态消失后

function loginDisappears() {
	mui.toast("登录状态已消失,请重新登录!");
	setTimeout(function() {
		plus.webview.show("login.html");
	}, 1500)
}

/**
 * 所有页面都需要调用的方法写在此处
 */
(function($) {
	$.plusReady(function() {
		//所有页面调用
		setStatusbarRed();
	});
})(mui);

/**
 * js里动态引入js文件
 * 避免在每个页面再添加相应的js文件
 * @param src
 * @param callback
 */
function loadJs(src, callback) {
	var script = document.createElement("script");
	script.type = "text/javascript";
	script.src = src;
	document.getElementsByTagName('head')[0].appendChild(script);
	setTimeout(callback, 100);
}

//自定义等待样式
function showWaiting(msg) {
	var message = msg || "拼命加载中...";
	var options = new Object();
	options.background = "rgba(255,255,255,0)";
	options.color = "rgba(0,0,0,0.8)";
	var loadOption = new Object();
	loadOption.icon = "_www/images/load/defaultloading.png"
	loadOption.interval = 100;
	options.loading = loadOption;
	plus.nativeUI.showWaiting(message, options);
}

/*
 *********-------------------------------
 * 上传图相相关操作
 * *******-------------------------------
 * **/

/**
 ********======================
 * 工具方法
 * ******======================
 * *
 */

var COMMD5 = function(string) {

	function RotateLeft(lValue, iShiftBits) {
		return(lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
	}

	function AddUnsigned(lX, lY) {
		var lX4, lY4, lX8, lY8, lResult;
		lX8 = (lX & 0x80000000);
		lY8 = (lY & 0x80000000);
		lX4 = (lX & 0x40000000);
		lY4 = (lY & 0x40000000);
		lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
		if(lX4 & lY4) {
			return(lResult ^ 0x80000000 ^ lX8 ^ lY8);
		}
		if(lX4 | lY4) {
			if(lResult & 0x40000000) {
				return(lResult ^ 0xC0000000 ^ lX8 ^ lY8);
			} else {
				return(lResult ^ 0x40000000 ^ lX8 ^ lY8);
			}
		} else {
			return(lResult ^ lX8 ^ lY8);
		}
	}

	function F(x, y, z) {
		return(x & y) | ((~x) & z);
	}

	function G(x, y, z) {
		return(x & z) | (y & (~z));
	}

	function H(x, y, z) {
		return(x ^ y ^ z);
	}

	function I(x, y, z) {
		return(y ^ (x | (~z)));
	}

	function FF(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};

	function GG(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};

	function HH(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};

	function II(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	};

	function ConvertToWordArray(string) {
		var lWordCount;
		var lMessageLength = string.length;
		var lNumberOfWords_temp1 = lMessageLength + 8;
		var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
		var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
		var lWordArray = Array(lNumberOfWords - 1);
		var lBytePosition = 0;
		var lByteCount = 0;
		while(lByteCount < lMessageLength) {
			lWordCount = (lByteCount - (lByteCount % 4)) / 4;
			lBytePosition = (lByteCount % 4) * 8;
			lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition));
			lByteCount++;
		}
		lWordCount = (lByteCount - (lByteCount % 4)) / 4;
		lBytePosition = (lByteCount % 4) * 8;
		lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
		lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
		lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
		return lWordArray;
	};

	function WordToHex(lValue) {
		var WordToHexValue = "",
			WordToHexValue_temp = "",
			lByte, lCount;
		for(lCount = 0; lCount <= 3; lCount++) {
			lByte = (lValue >>> (lCount * 8)) & 255;
			WordToHexValue_temp = "0" + lByte.toString(16);
			WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length - 2, 2);
		}
		return WordToHexValue;
	};

	function Utf8Encode(string) {
		string = string.replace(/\r\n/g, "\n");
		var utftext = "";

		for(var n = 0; n < string.length; n++) {

			var c = string.charCodeAt(n);

			if(c < 128) {
				utftext += String.fromCharCode(c);
			} else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}

		return utftext;
	};

	var x = Array();
	var k, AA, BB, CC, DD, a, b, c, d;
	var S11 = 7,
		S12 = 12,
		S13 = 17,
		S14 = 22;
	var S21 = 5,
		S22 = 9,
		S23 = 14,
		S24 = 20;
	var S31 = 4,
		S32 = 11,
		S33 = 16,
		S34 = 23;
	var S41 = 6,
		S42 = 10,
		S43 = 15,
		S44 = 21;

	string = Utf8Encode(string);

	x = ConvertToWordArray(string);

	a = 0x67452301;
	b = 0xEFCDAB89;
	c = 0x98BADCFE;
	d = 0x10325476;

	for(k = 0; k < x.length; k += 16) {
		AA = a;
		BB = b;
		CC = c;
		DD = d;
		a = FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
		d = FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
		c = FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
		b = FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
		a = FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
		d = FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
		c = FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
		b = FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
		a = FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
		d = FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
		c = FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
		b = FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
		a = FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
		d = FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
		c = FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
		b = FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
		a = GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
		d = GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
		c = GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
		b = GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
		a = GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
		d = GG(d, a, b, c, x[k + 10], S22, 0x2441453);
		c = GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
		b = GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
		a = GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
		d = GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
		c = GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
		b = GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
		a = GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
		d = GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
		c = GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
		b = GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
		a = HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
		d = HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
		c = HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
		b = HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
		a = HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
		d = HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
		c = HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
		b = HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
		a = HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
		d = HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
		c = HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
		b = HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
		a = HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
		d = HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
		c = HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
		b = HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
		a = II(a, b, c, d, x[k + 0], S41, 0xF4292244);
		d = II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
		c = II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
		b = II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
		a = II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
		d = II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
		c = II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
		b = II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
		a = II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
		d = II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
		c = II(c, d, a, b, x[k + 6], S43, 0xA3014314);
		b = II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
		a = II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
		d = II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
		c = II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
		b = II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
		a = AddUnsigned(a, AA);
		b = AddUnsigned(b, BB);
		c = AddUnsigned(c, CC);
		d = AddUnsigned(d, DD);
	}

	var temp = WordToHex(a) + WordToHex(b) + WordToHex(c) + WordToHex(d);

	return temp.toLowerCase();
}