/**
 * 推送服务
 */

//初始化推送监听，在plusReady里面调用
function initApns(){
	document.addEventListener( "plusready", function(){
	    // 监听推送消息到达时的点击事件
	    plus.push.addEventListener( "click", function( msg ) {
	        // 判断是从本地创建还是离线推送的消息
	        switch( msg.payload ) {
	            case "LocalMSG":
	                plus.nativeUI.toast( "点击本地创建消息启动：" );
	            break;
	            default:
	                plus.nativeUI.toast( "点击离线推送消息启动：");
	            break;
	        }
	        // 提示点击的内容
	        plus.ui.toast( msg.content );
	        // 处理数据
	        doPushMsg( msg );
	    }, false );
	    
	    // 监听在线消息事件,可处理透传消息
	    plus.push.addEventListener( "receive", function( msg ) {
	        if ( msg.aps ) {  // Apple APNS message
	            plus.nativeUI.toast( "接收到在线APNS消息：" );
	        } else {
	            plus.nativeUI.toast( "接收到在线透传消息：" );
	        }
	        doPushMsg( msg );
	    }, false );
	}, false );
}

//处理push的消息
function doPushMsg(msg){
	if(msg){
		if ( msg.payload ) {
			if ( typeof(msg.payload)=="string" ) {
				plus.nativeUI.alert(msg.payload );
			} else {
				var pd = JSON.stringify(msg.payload);
				//获取格式，待处理
			}
		}
	}
}
